<?php
require __DIR__."/autoloader.php";
require __DIR__."/vendor/autoload.php";
require __DIR__."/vendor/zeedhi/framework/bootstrap.php";
require __DIR__ . "/vendor/teknisa/libraries/scripts/bootstrap.php";

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$environment = __DIR__.'/../../../backend/config/environment.xml';
$db = __DIR__.'/../../../backend/config/db.xml';
$report = __DIR__.'/../../../backend/config/report.xml';
$parameters = __DIR__.'/../../../backend/config/parameters.xml';
$general = __DIR__.'/../../../backend/config/general.xml';

if (realpath($parameters)) $instanceManager->loadFromFile($parameters);

$container = $instanceManager->getContainer();

$routes = array();
$routes[] = __DIR__ . '/config/routes.json';
$routes[] = __DIR__ . '/vendor/teknisa/libraries/libRoutes.json';


if (!realpath($report))     $report = __DIR__ . "/config/report.xml";
if (realpath($general))     $instanceManager->loadFromFile($general);
if (realpath($environment)) $instanceManager->loadFromFile($environment);
if (realpath($parameters))  $instanceManager->loadFromFile($parameters);

$instanceManager->loadFromFile($db);
$instanceManager->loadFromFile(__DIR__ . '/config/environment.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/controllers.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/services.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/repositories.xml');

$instanceManager->loadFromFile(__DIR__ . '/config/dependencies.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/configParams.xml');

if (realpath($report)) $instanceManager->loadFromFile($report);

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));
$instanceManager->compile();
